<template>
  <div>
    <label class="label-formulario" :for="label + random"> {{ label }}</label>
    <q-input
      :type="type"
      :outlined="outlined"
      v-model="value"
      :dense="dense"
      :disable="disable"
      :error-message="
        errors && errors[variable] ? errors[variable][0] : '' || message
      "
      :error="errors[variable] || message ? true : false"
    >
      <template v-slot:prepend>
        <template v-if="icon">
          <q-icon :name="icon" />
        </template>
      </template>
    </q-input>
  </div>
</template>
<script>
export default {
  props: {
    label: String,
    variable: String,
    message: String,
    errors: Object,
    outlined: Boolean,
    dense: Boolean,
    valueParent: String,
    disable: Boolean,
    icon: String,
    type: String,
  },
  data() {
    return {
      value: "",
      random: Math.ceil(Math.random() * 10),
    };
  },
  watch: {
    valueParent: {
      immediate: true,
      handler: function (newValue) {
        this.value = newValue;
      },
    },
    value: function (newValue, oldValue) {
      this.$emit("update:value", newValue);
    },
  },
};
</script>